 /* generate date/time 23 Nov 1993 13:32:13 */
 
#ifndef SPM_COUNTERS_DEFINED 
#define SPM_COUNTERS_DEFINED 
 
 typedef unsigned long internal; /* TypeFld = 0 */ 
 typedef float timer; /* TypeFld = 1 */ 
 typedef unsigned long counter; /* TypeFld = 2 */ 
 typedef struct { timer tv; counter ct; } queue; /* TypeFld = 3 */ 
 typedef unsigned long constant; /* TypeFld = 4 */ 
 typedef float bulkcounter; /* TypeFld = 5 */ 
 typedef float statetimer; /* TypeFld = 6 */ 
 typedef unsigned long statecounter; /* TypeFld = 7 */ 
 typedef float bulkstatecounter; /* TypeFld = 8 */ 
 typedef timer idletimer; /* TypeFld = 9 */ 
 
 /* spm level 02.00.00, os2 level 02.00.00 */
 
#ifndef SPMOrdinal_CPU
#define SPMOrdinal_CPU 3
 typedef
  struct _CPU {   /* "CPU" - "CPU" */
   idletimer tvNotIdle;   /* "tmNotIdle" - "processor time" */
   counter ctSched;   /* "ctSched" - "num scheduled" */
   counter ctInt;   /* "ctInt" - "num interrupts" */
   timer tvInt;   /* "tmInt" - "interrupt time" */
#ifdef SPMCtrGpExtension_CPU
       SPMCtrGpExtension_CPU
#endif
  } CPU;
#endif
 
#ifndef SPMOrdinal_THD
#define SPMOrdinal_THD 4
 typedef
  struct _THD {   /* "THD" - "Thread" */
   counter ctSched;   /* "ctSched" - "num scheduled" */
   timer tvRun;   /* "tmRun" - "run time" */
   internal ctFlg;   /* "ctFlg" - "ctFlg" */
   timer tvReady;   /* "tmReady" - "ready time" */
   counter ctFault;   /* "ctFault" - "num faults" */
   timer tvFault;   /* "tmFault" - "fault time" */
   timer tvFileIOWait;   /* "tmFileIOWait" - "file i/o wait" */
#ifdef SPMCtrGpExtension_THD
       SPMCtrGpExtension_THD
#endif
  } THD;
#endif
 
#ifndef SPMOrdinal_MEM
#define SPMOrdinal_MEM 5
 typedef
  struct _MEM {   /* "MEM" - "Memory" */
   counter ctPgFault;   /* "ctPgFault" - "num faults" */
   counter ctSwapIn;   /* "ctSwapIn" - "num swapped in" */
   counter ctDemandLd;   /* "ctDemandLd" - "num demand loaded" */
   counter ctSwapOut;   /* "ctSwapOut" - "num swapped out" */
   counter ctDiscard;   /* "ctDiscard" - "num discarded" */
   counter ctRecovered;   /* "ctRecovered" - "num recovered" */
   counter ctIdled;   /* "ctIdled" - "num idled" */
   counter ctReassigned;   /* "ctReassigned" - "num reassigned" */
   internal ctResident;   /* "qctResident" - "internal use only" */
   queue qlQFree;   /* "qlQFree" - "free queue length" */
   queue qlQUsed;   /* "qlQUsed" - "used queue length" */
#ifdef SPMCtrGpExtension_MEM
       SPMCtrGpExtension_MEM
#endif
  } MEM;
#endif
 
#ifndef SPMOrdinal_FIL
#define SPMOrdinal_FIL 6
 typedef
  struct _FIL {   /* "FIL" - "Files" */
   counter ctRd;   /* "ctRd" - "num reads" */
   timer tvRd;   /* "tmRd" - "read time" */
   counter ctRdByte;   /* "ctRdByte" - "num read bytes" */
   counter ctWrt;   /* "ctWrt" - "num writes" */
   timer tvWrt;   /* "tmWrt" - "write time" */
   counter ctWrtByte;   /* "ctWrtByte" - "num write bytes" */
#ifdef SPMCtrGpExtension_FIL
       SPMCtrGpExtension_FIL
#endif
  } FIL;
#endif
 
#ifndef SPMOrdinal_FBC
#define SPMOrdinal_FBC 7
 typedef
  struct _FBC {   /* "FBC" - "FAT cache" */
   counter ctRdHit;   /* "ctRdHit" - "cache read hits" */
   counter ctRdMiss;   /* "ctRdMiss" - "cache read misses" */
   counter ctWrtHit;   /* "ctWrtHit" - "cache write hits" */
   counter ctWrtMiss;   /* "ctWrtMiss" - "cache write misses" */
   counter ctWrtActiv;   /* "ctWrtActiv" - "forced write activations" */
   counter ctBypass;   /* "ctBypass" - "deliberate cache bypass" */
#ifdef SPMCtrGpExtension_FBC
       SPMCtrGpExtension_FBC
#endif
  } FBC;
#endif
 
#ifndef SPMOrdinal_HBC
#define SPMOrdinal_HBC 9
 typedef
  struct _HBC {   /* "HPFS" - "HPFS cache" */
   counter ctNHints;   /* "CTCaNHints" - "next pbuf hints" */
   counter ctNHits;   /* "CTCaNHits" - "next pbuf hits" */
   counter ctNSelf;   /* "CTCaNSelf" - "next pbuf self" */
   counter ctBHints;   /* "CTCaBHints" - "pbuf hints" */
   counter ctBHits;   /* "CTCaBHits" - "pbuf hint hits" */
   counter ctForceL;   /* "CTCaForceL" - "force lazy" */
   constant ctHpSize;   /* "CTHpSize" - "heap size" */
   constant ctHpAlloc;   /* "QCHpAlloc" - "heap allocated" */
   constant ctHpSbdirs;   /* "QCHpSbdirs" - "heap allocated to subdirectories" */
   constant ctHpObj;   /* "QCHpObjCnt" - "heap object count" */
   counter ctFOpen;   /* "CTFOCount" - "files open" */
   counter ctFClose;   /* "CTFCCount" - "files closed" */
   constant ctFWCur;   /* "QCFWCurCnt" - "files currently written" */
   counter ctFRFil;   /* "CTFRFilCnt" - "files closed read only" */
   counter ctFRSeqFil;   /* "CTFRSeqFil" - "files closed read sequential" */
   counter ctFAcc;   /* "CTFACount" - "file allocation access" */
   counter ctFAOft;   /* "CTFAOft" - "file allocation access often" */
   counter ctRABuf;   /* "CTRABufCnt" - "read ahead blocks" */
   counter ctRABufAcc;   /* "QCRABufAcc" - "read ahead buf accesses" */
   counter ctRABufHit;   /* "CTRABufHit" - "read ahead buf hits" */
   counter ctRAOvrWrt;   /* "CTRAOvrWrt" - "read ahead overwritten" */
   counter ctHit;   /* "CTCaHit" - "pbuf hits" */
   counter ctMiss;   /* "CTCaMiss" - "pbuf misses" */
#ifdef SPMCtrGpExtension_HBC
       SPMCtrGpExtension_HBC
#endif
  } HBC;
#endif
 
#ifndef SPMOrdinal_WKS
#define SPMOrdinal_WKS 10
 typedef
  struct _WKS {   /* "WorkingSet" - "Working Set" */
   queue qlQResident;   /* "Resident" - "resident queue length" */
   queue qlQWorking;   /* "WorkingSet" - "working set queue length" */
   queue qlQPresent;   /* "Used" - "used queue length" */
   constant ctMemSize;   /* "Total" - "memory size" */
#ifdef SPMCtrGpExtension_WKS
       SPMCtrGpExtension_WKS
#endif
  } WKS;
#endif
 
#ifndef SPMOrdinal_DSK
#define SPMOrdinal_DSK 15
 typedef
  struct _DSK {   /* "DISK 01" - "Disk 01" */
   counter ctRd;   /* "ctRD" - "num reads" */
   queue qlQRd;   /* "qlRD" - "read queue length" */
   counter ctRdBlock;   /* "blRD" - "read blocks" */
   counter ctWrt;   /* "ctWR" - "num writes" */
   queue qlQWrt;   /* "qlWR" - "write queue length" */
   counter ctWrtBlock;   /* "blWR" - "write blocks" */
   timer tvBusy;   /* "tmBUSY" - "busy time" */
#ifdef SPMCtrGpExtension_DSK
       SPMCtrGpExtension_DSK
#endif
  } DSK;
#endif
  /* Ordinal 16 "DISK 02" is an alias for "DISK 01" */
  /* Ordinal 17 "DISK 03" is an alias for "DISK 01" */
  /* Ordinal 18 "DISK 04" is an alias for "DISK 01" */
  /* Ordinal 19 "DISK 05" is an alias for "DISK 01" */
  /* Ordinal 20 "DISK 06" is an alias for "DISK 01" */
  /* Ordinal 21 "DISK 07" is an alias for "DISK 01" */
  /* Ordinal 22 "DISK 08" is an alias for "DISK 01" */
  /* Ordinal 23 "DISK 09" is an alias for "DISK 01" */
  /* Ordinal 24 "DISK 10" is an alias for "DISK 01" */
  /* Ordinal 25 "DISK 11" is an alias for "DISK 01" */
  /* Ordinal 26 "DISK 12" is an alias for "DISK 01" */
  /* Ordinal 27 "DISK 13" is an alias for "DISK 01" */
  /* Ordinal 28 "DISK 14" is an alias for "DISK 01" */
  /* Ordinal 29 "DISK 15" is an alias for "DISK 01" */
  /* Ordinal 30 "DISK 16" is an alias for "DISK 01" */
  /* Ordinal 31 "DISK 17" is an alias for "DISK 01" */
  /* Ordinal 32 "DISK 18" is an alias for "DISK 01" */
  /* Ordinal 33 "DISK 19" is an alias for "DISK 01" */
  /* Ordinal 34 "DISK 20" is an alias for "DISK 01" */
  /* Ordinal 35 "DISK 21" is an alias for "DISK 01" */
  /* Ordinal 36 "DISK 22" is an alias for "DISK 01" */
  /* Ordinal 37 "DISK 23" is an alias for "DISK 01" */
  /* Ordinal 38 "DISK 24" is an alias for "DISK 01" */
 
#ifndef SPMOrdinal_PRT
#define SPMOrdinal_PRT 42
 typedef
  struct _PRT {   /* "Parallel Port Device Driver" - "Printer 1" */
   counter ctWrt;   /* "LPT1 Write Requests" - "num writes" */
   timer tvWrt;   /* "LPT1 Write Time" - "write time" */
   counter ctWrtByte;   /* "LPT1 Write Bytes" - "num write bytes" */
#ifdef SPMCtrGpExtension_PRT
       SPMCtrGpExtension_PRT
#endif
  } PRT;
#endif
  /* Ordinal 43 "Parallel Port Device Driver 2" is an alias for "Parallel Port Device Driver" */
  /* Ordinal 44 "Parallel Port Device Driver 3" is an alias for "Parallel Port Device Driver" */
  /* Ordinal 45 "Parallel Port Device Driver 4" is an alias for "Parallel Port Device Driver" */
 
#ifndef SPMOrdinal_COM
#define SPMOrdinal_COM 46
 typedef
  struct _COM {   /* "COM1" - "COM port 1" */
   timer tvRd;   /* "Read Time" - "read time" */
   timer tvWrt;   /* "Write Time" - "write time" */
   counter ctRd;   /* "Number Reads" - "num reads" */
   counter ctRdByte;   /* "Bytes Read" - "num read bytes" */
   counter ctWrt;   /* "Number Writes" - "num write" */
   counter ctWrtByte;   /* "Bytes Written" - "num write bytes" */
   counter ctHrdOver;   /* "Hardware Overruns" - "num hardware overruns" */
   counter ctSftOver;   /* "Software Overruns" - "num software overruns" */
#ifdef SPMCtrGpExtension_COM
       SPMCtrGpExtension_COM
#endif
  } COM;
#endif
  /* Ordinal 47 "COM2" is an alias for "COM1" */
  /* Ordinal 48 "COM3" is an alias for "COM1" */
  /* Ordinal 49 "COM4" is an alias for "COM1" */
 
#ifndef SPMOrdinal_HPFS386
#define SPMOrdinal_HPFS386 200
 typedef
  struct _HPFS386 {   /* "HPFS386" - "IBM LS 3.0 Advanced" */
   bulkcounter H386_BCCaRdReqC;   /* "BCCaRdReqC" - "BCCaRdReqC" */
   bulkcounter H386_BCCaRdReqD;   /* "BCCaRdReqD" - "BCCaRdReqD" */
   bulkcounter H386_BCCaWrReqD;   /* "BCCaWrReqD" - "BCCaWrReqD" */
   bulkcounter H386_BCCaWrReqL;   /* "BCCaWrReqL" - "BCCaWrReqL" */
   counter H386_CTCaForceL;   /* "CTCaForceL" - "CTCaForceL" */
   counter H386_CTCaNumBlk;   /* "CTCaNumBlk" - "CTCaNumBlk" */
   statecounter H386_CTHpSize;   /* "CTHpSize" - "CTHpSize" */
   statecounter H386_CTHpMax;   /* "CTHpMax" - "CTHpMax" */
   counter H386_CTHpFull;   /* "CTHpFull" - "CTHpFull" */
   counter H386_CTFOCount;   /* "CTFOCount" - "CTFOCount" */
   counter H386_CTFCCount;   /* "CTFCCount" - "CTFCCount" */
   statecounter H386_SCFWCurCnt;   /* "SCFWCurCnt" - "SCFWCurCnt" */
   counter H386_CTFRFilCnt;   /* "CTFRFilCnt" - "CTFRFilCnt" */
   counter H386_CTFRSeqFil;   /* "CTFRSeqFil" - "CTFRSeqFil" */
   counter H386_CTRABufCnt;   /* "CTRABufCnt" - "CTRABufCnt" */
   counter H386_CTRABufHit;   /* "CTRABufHit" - "CTRABufHit" */
   counter H386_CTRAOvrWrt;   /* "CTRAOvrWrt" - "CTRAOvrWrt" */
   counter H386_CTRAWhFile;   /* "CTRAWhFile" - "CTRAWhFile" */
   counter H386_CTR0TransP;   /* "CTR0TransP" - "CTR0TransP" */
   counter H386_CTR0FilOpn;   /* "CTR0FilOpn" - "CTR0FilOpn" */
   counter H386_CTR0FilCls;   /* "CTR0FilCls" - "CTR0FilCls" */
   counter H386_CTR0OpLock;   /* "CTR0OpLock" - "CTR0OpLock" */
   counter H386_CTR0OpBrk;   /* "CTR0OpBrk" - "CTR0OpBrk" */
   counter H386_CTR0SmRds;   /* "CTR0SmRds" - "CTR0SmRds" */
   timer H386_TMR0SmRds;   /* "TMR0SmRds" - "TMR0SmRds" */
   bulkcounter H386_BCR0SmByRd;   /* "BCR0SmByRd" - "BCR0SmByRd" */
   counter H386_CTR0MpxRds;   /* "CTR0MpxRds" - "CTR0MpxRds" */
   timer H386_TMR0MpxRds;   /* "TMR0MpxRds" - "TMR0MpxRds" */
   bulkcounter H386_BCR0MpxByR;   /* "BCR0MpxByR" - "BCR0MpxByR" */
   counter H386_CTR0RawRds;   /* "CTR0RawRds" - "CTR0RawRds" */
   timer H386_TMR0RawRds;   /* "TMR0RawRds" - "TMR0RawRds" */
   bulkcounter H386_BCR0RawByR;   /* "BCR0RawByR" - "BCR0RawByR" */
   counter H386_CTR0RdCaBp;   /* "CTR0RdCaBp" - "CTR0RdCaBp" */
   counter H386_CTR0SmWrt;   /* "CTR0SmWrt" - "CTR0SmWrt" */
   timer H386_TMR0SmWrt;   /* "TMR0SmWrt" - "TMR0SmWrt" */
   bulkcounter H386_BCR0SmByWr;   /* "BCR0SmByWr" - "BCR0SmByWr" */
   counter H386_CTR0MpxWrt;   /* "CTR0MpxWrt" - "CTR0MpxWrt" */
   timer H386_TMR0MpxWrt;   /* "TMR0MpxWrt" - "TMR0MpxWrt" */
   bulkcounter H386_BCR0MpxByW;   /* "BCR0MpxByW" - "BCR0MpxByW" */
   counter H386_CTR0RawWrt;   /* "CTR0RawWrt" - "CTR0RawWrt" */
   timer H386_TMR0RawWrt;   /* "TMR0RawWrt" - "TMR0RawWrt" */
   bulkcounter H386_BCR0RawByW;   /* "BCR0RawByW" - "BCR0RawByW" */
   counter H386_CTR0WrCaBp;   /* "CTR0WrCaBp" - "CTR0WrCaBp" */
   statecounter H386_SCR0CurFnd;   /* "SCR0CurFnd" - "SCR0CurFnd" */
   statecounter H386_SCR0OSrch;   /* "SCR0OSrch" - "SCR0OSrch" */
   statecounter H386_SCR0BigBuf;   /* "SCR0BigBuf" - "SCR0BigBuf" */
   counter H386_CTR0BBufEx;   /* "CTR0BBufEx" - "CTR0BBufEx" */
#ifdef SPMCtrGpExtension_HPFS386
       SPMCtrGpExtension_HPFS386
#endif
  } HPFS386;
#endif
 
#ifndef SPMOrdinal_REQ
#define SPMOrdinal_REQ 201
 typedef
  struct _REQ {   /* "NETWKST" - "IBM LAN Requester" */
   constant LR_CTRqTransP;   /* "CTRqTransP" - "CTRqTransP" */
   counter LR_CTRqFoCount;   /* "CTRqFoCount" - "CTRqFoCount" */
   counter LR_CTRqFcCount;   /* "CTRqFcCount" - "CTRqFcCount" */
   counter LR_CTRqSmRds;   /* "CTRqSmRds" - "CTRqSmRds" */
   timer LR_TMRqSmRds;   /* "TMRqSmRds" - "TMRqSmRds" */
   bulkcounter LR_BCRqSmByRd;   /* "BCRqSmByRd" - "BCRqSmByRd" */
   counter LR_CTRqMpxRds;   /* "CTRqMpxRds" - "CTRqMpxRds" */
   timer LR_TMRqMpxRds;   /* "TMRqMpxRds" - "TMRqMpxRds" */
   bulkcounter LR_BCRqMpxByR;   /* "BCRqMpxByR" - "BCRqMpxByR" */
   counter LR_CTRqRawRds;   /* "CTRqRawRds" - "CTRqRawRds" */
   timer LR_TMRqRawRds;   /* "TMRqRawRds" - "TMRqRawRds" */
   bulkcounter LR_BCRqRawByR;   /* "BCRqRawByR" - "BCRqRawByR" */
   bulkcounter LR_BCRqTotRds;   /* "BCRqTotRds" - "BCRqTotRds" */
   counter LR_CTRqSmWrt;   /* "CTRqSmWrt" - "CTRqSmWrt" */
   timer LR_TMRqSmWrt;   /* "TMRqSmWrt" - "TMRqSmWrt" */
   bulkcounter LR_BCRqSmByWr;   /* "BCRqSmByWr" - "BCRqSmByWr" */
   counter LR_CTRqMpxWrt;   /* "CTRqMpxWrt" - "CTRqMpxWrt" */
   timer LR_TMRqMpxWrt;   /* "TMRqMpxWrt" - "TMRqMpxWrt" */
   bulkcounter LR_BCRqMpxByW;   /* "BCRqMpxByW" - "BCRqMpxByW" */
   counter LR_CTRqRawWrt;   /* "CTRqRawWrt" - "CTRqRawWrt" */
   timer LR_TMRqRawWrt;   /* "TMRqRawWrt" - "TMRqRawWrt" */
   bulkcounter LR_BCRqRawByW;   /* "BCRqRawByW" - "BCRqRawByW" */
   bulkcounter LR_BCRqTotWrt;   /* "BCRqTotWrt" - "BCRqTotWrt" */
#ifdef SPMCtrGpExtension_REQ
       SPMCtrGpExtension_REQ
#endif
  } REQ;
#endif
 
#endif /* end of SPM_COUNTERS_DEFINED */
