/**/
  parse upper arg PARMSTRING

  /* set up system environment */

  FunctionList = '>SPMAPPFS',
                              'GetMsg' 'PutMsg' 'PutDot',
                              'LoadCmd' 'DropCmd',
                              'Push' 'Pop',
                              'szstr' 'd2s' 'd2l' 's2d' 'l2d',
                 '>RexxUtil',
                              'SysIni' 'SysSearchPath',
                 '.Commands',
                              'SPMAPP01' 'SPMAPP02' 'SPMAPP03',
                              'SPMAPP04' 'SPMAPP05'

  rc = LoadFunctions()

  if rc <> 0 then signal QUIT

  /* parse parameters */

  x = strip(PARMSTRING)

  if x = '' | x = '?'
  then
    do
      rc = SPMAPP04(APPMSG)
      signal QUIT
    end

  parse var PARMSTRING 'TEXT(' TXTFILE ')'
  parse var PARMSTRING 'INI(' INIFILE ')'
  parse var PARMSTRING 'OUT(' OUTFILE ')'

  if TXTFILE = '' then TXTFILE = strip(arg(1))

  if pos('.',TXTFILE) = 0 then TXTFILE = TXTFILE||'.SPM'

  path = stream(TXTFILE,'c','query exists')

  if path = ''
  then
    do
      say GetMsg(3,TXTFILE)
      rc = 3
      signal QUIT
    end

  TXTFILE = path

  if OUTFILE = '' then OUTFILE = filespec('Drive',TXTFILE)||,
                                 filespec('Path', TXTFILE)

  if INIFILE = '' then INIFILE = 'SPMAPP.INI'

  path = SysSearchPath('DPATH',INIFILE)

  if path = ''
  then
    do
      say GetMsg(4,INIFILE)
      rc = 4
      signal QUIT
    end

  INIFILE = path

  /* process the files */

  say GetMsg(5,TXTFILE,INIFILE)

  x = Push('APPMSG' 'TXTFILE' 'INIFILE')

  rc = SPMAPP01()

  if rc <> 0 then signal QUIT

  x = Push('APPMSG' 'INIFILE' 'OUTFILE')

  rc = SPMAPP03()

  if rc <> 0 then signal QUIT

QUIT:
  if rc > 9900 then GetMsg(7,substr(rc,3))

  say GetMsg(6)

  x = DropFunctions()

  return rc

 /* * * * * */

LoadFunctions:
  Do i = 1 to words(FunctionList)
    f = word(FunctionList,i)

    select
      when substr(f,1,1) = '>' then lib = substr(f,2)
      when substr(f,1,1) = '.' then lib = ''
      otherwise
        do
          if lib = ''
          then
            do
              path = SysSearchPath('PATH',f||'.CMD')

              if LoadCmd(f,path) = 0
              then
                  DropList = '.'||f||' '||DropList
              else
                do
                  say GetMsg(1,f)
                  return 1
                end
            end
          else
            do
              if RxFuncQuery(f) <> 0
              then
                do
                  if RxFuncAdd(f,lib,f) = 0
                  then
                      DropList = DropList||' >'||f
                  else
                    do
                      say GetMsg(2,Func.i,FuncLib)
                      return 2
                    end
                end
            end
        end /* otherwise */
    end /* select */

  end /* Do i ... */
  return 0

DropFunctions:
  Do i = 1 to words(DropList)

    f = word(DropList,i)

    select
      when substr(f,1,1) = '.' then x = DropCmd(substr(f,2))
      when substr(f,1,1) = '>' then x = RxFuncDrop(substr(f,2))
      otherwise
    end

  end
  return 0

